//############################################################################
//
// LaserBoy !!!
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#ifndef __EZ_UAIL_DEFINITIONS__
#define __EZ_UAIL_DEFINITIONS__

//############################################################################
#include "ez_uail_header.hpp"
#include "ez_uail_frame_set.hpp"
#include "ez_palette_set.hpp"
#include "ez_bmp.hpp"

//############################################################################
class ez_uail : public ez_uail_frame_set, public ez_palette_set
{
public:
       
    ez_uail()
               : ez_uail_frame_set()
               , ez_palette_set   ()
                {}
    //------------------------------------------------------------------------
    ez_uail(const ez_uail_frame_set& frames)
               : ez_uail_frame_set()
               , ez_palette_set   ()  
                {
                    ez_uail_frame_set::insert(   ez_uail_frame_set::end()
                                               , frames.begin()
                                               , frames.end()
                                             );
                    renumber();
                }
    //------------------------------------------------------------------------
virtual
   ~ez_uail()   {}
    //------------------------------------------------------------------------
    ez_uail_frame& operator [] (int index) // does not set frame_index
                    {
                        if(number_of_frames())
                        {
                            if(index >= number_of_frames())
                                index = 0;
                            if(index < 0)
                                index = number_of_frames() - 1;
                            return ez_uail_frame_set::at(index);
                        }
                        return null_frame;
                    }
    //------------------------------------------------------------------------
    ez_uail& operator += (const ez_uail_frame_set& frames)
                {
                    ez_uail_frame_set::insert(ez_uail_frame_set::end(), frames.begin(), frames.end());
                    renumber();
                    return *this;
                }
    //------------------------------------------------------------------------
    ez_uail& operator  = (const ez_uail_frame_set& frames)
                {
                    ez_uail_frame_set::clear();
                    ez_uail_frame_set::insert(ez_uail_frame_set::end(), frames.begin(), frames.end());
                    renumber();
                    return *this;
                }
    //------------------------------------------------------------------------
    ez_uail& operator += (const ez_uail_frame& frame)
                {
                    ez_uail_frame_set::push_back(frame);
                    renumber();
                    return *this;
                }
    //------------------------------------------------------------------------
    ez_uail& operator += (const ez_palette_set& palettes)
                {
                    ez_palette_set::insert(ez_palette_set::end(), palettes.begin(), palettes.end());
                    return *this;
                }
    //------------------------------------------------------------------------
    ez_uail& operator += (const ez_palette& palette)
                {
                    ez_palette_set::push_back(palette);
                    return *this;
                }  
    //------------------------------------------------------------------------
    void     clear_frames()
                {
                    ez_uail_frame_set::clear();
                    return;
                }
    //------------------------------------------------------------------------
    void     clear_palettes()
                {
                    ez_palette_set::clear();
                    return;
                }
    //------------------------------------------------------------------------
    void     clear_unused_palettes     ();
    void     sync_rgb_and_palette      ();
    void     best_reduce_all_to_palette();
    //------------------------------------------------------------------------
};

//############################################################################
#endif

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
