//############################################################################
//
// LaserBoy !!!
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#include "ez_uail_gui.hpp"

//############################################################################
int linear_steps(   const ez_uail_point p1
                  , const ez_uail_point p2
                  , const double delta_max
                )
{
    return (int)(ceil((p1 | p2) / delta_max));
}

//############################################################################
int bullistic_steps(   const ez_uail_point p1
                     , const ez_uail_point p2
                     , const double acceleration
                   )
{
    return (int)( ((p1 | p2) / 2)   );
}

//############################################################################
int dwell_points(double angle) // zero to pi radians
{
    return (int)(ceil(    angle / pi // zero to one
                       * (    AIL->sample_rate
                           * (AIL->longest_dwell_microsec / 1000000.0)
                         )
                     )
                );
}

//############################################################################
u_int next_hue()
{
    static int i = 0;    
    switch(i++ % 12)
    {
        case 0:
            return BMP.make_rgb(255,0,0);
        case 1:
            return BMP.make_rgb(255,128,0);
        case 2:
            return BMP.make_rgb(255,255,0);
        case 3:
            return BMP.make_rgb(128,255,0);
        case 4:
            return BMP.make_rgb(0,255,0);
        case 5:
            return BMP.make_rgb(0,255,128);
        case 6:
            return BMP.make_rgb(0,255,255);
        case 7:
            return BMP.make_rgb(0,128,255);
        case 8:
            return BMP.make_rgb(0,0,255);
        case 9:
            return BMP.make_rgb(128,0,255);
        case 10:
            return BMP.make_rgb(255,0,255);
        case 11:
            return BMP.make_rgb(255,0,128);
    }
    return 0;
}

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
